=== debian/changelog ===
kid3 (3.0.2-4) unstable; urgency=low

  * Add missing breaks/replaces.
    Closes: #738712
  * Adjust lintian overrides.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 20 Feb 2014 11:20:28 +0100

kid3 (3.0.2-3) unstable; urgency=low

  * Do not compress docbooks.
  * Add missing license in debian/copyright for vcedit.*
    Closes: #738630

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 12 Feb 2014 09:39:06 +0100

kid3 (3.0.2-2) unstable; urgency=low

  [ Ana Guerrero Lopez ]
  * Remove myself from Uploaders.

  [ Patrick Matthäi ]
  * Reintroduce kid3-qt package.
  * Add kid3-core package on which the other variants depend.
  * Cosmetic fix in last changelog entry.
  * Use manpages from upstream packaging.
  * Overwrite debian-watch-may-check-gpg-signature, no GPG signature available.
  * Add patch 01-desktop-keywords to fix lintian warning
    desktop-entry-lacks-keywords-entry.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 30 Jan 2014 12:53:19 +0100

kid3 (3.0.2-1) unstable; urgency=low

  [ Patrick Matthäi ]
  * New upstream release.
    - Add new libreadline-dev build dependency.
  * Don't explicitly request xz compression - dpkg 1.17 does this by default.
  * Bump Standards-Version to 3.9.5 (no changes needed).
  * Fix Vcs-Browser control field.

  [ Mark Purcell ]
  * Switch to dh - reduce debian/rules bloat
  * kid3 Replaces kid3-qt - low popcon, reduce archive bloat
  * Fix vcs-field-not-canonical
  * debian/compat -> 9
  * Update Description:

 -- Mark Purcell <msp@debian.org>  Sat, 30 Nov 2013 15:44:59 +1100
